import time
import smbus
import math
from time import sleep
bus = smbus.SMBus(1)

def resetPCA9685():
    bus.write_byte_data(address_pca9685, 0x00, 0x00)

def setPCA9685Freq(freq):
    freq = 0.9*freq # Arduinoのライブラリより
    prescaleval = 25000000.0    # 25MHz
    prescaleval /= 4096.0       # 12-bit
    prescaleval /= float(freq)
    prescaleval -= 1.0
    prescale = int(math.floor(prescaleval + 0.5))
    oldmode = bus.read_byte_data(address_pca9685, 0x00)
    newmode = (oldmode & 0x7F) | 0x10             # スリープモード
    bus.write_byte_data(address_pca9685, 0x00, newmode) # スリープモードへ
    bus.write_byte_data(address_pca9685, 0xFE, prescale) # プリスケーラーをセット
    bus.write_byte_data(address_pca9685, 0x00, oldmode)
    time.sleep(0.005)
    bus.write_byte_data(address_pca9685, 0x00, oldmode | 0xa1)

def setPCA9685Duty(channel, on, off):
    channelpos = 0x6 + 4*channel
    try:
        bus.write_i2c_block_data(address_pca9685, channelpos, [on&0xFF, on>>8, off&0xFF, off>>8] )
    except IOError:
       pass

def shoulder_move(ratio):
    duty=int(334*ratio)+109
    setPCA9685Duty(0, 0, duty)
def arm_move(ratio):
    duty=int(334*ratio)+109
    setPCA9685Duty(1, 0, duty)

def finger_move(ratio):
    duty=int(334*ratio)+109
    setPCA9685Duty(2, 0, duty)
        
def init_shoulder():
    shoulder_move(0.5)
    sleep(0.1)
    
def init_arm():
    arm_move(0.5)
    sleep(0.1)

def init_finger():
    finger_move(0.5)
    sleep(0.1)
def left_shoulder(angle, period ,count):
    interval=period/count
    delta=angle/count
    for i in range(count):
        shoulder_move(0.5+delta*i)
        sleep(interval)
 

# servo motorを用いるための設定

address_pca9685 = 0x40
resetPCA9685()
setPCA9685Freq(50)

init_shoulder()
init_arm()
init_finger()

#tracing arm movement
left_shoulder(-0.5, 6,100)



