import time
import smbus
import math
from time import sleep
bus = smbus.SMBus(1)


def resetPCA9685():
    bus.write_byte_data(address_pca9685, 0x00, 0x00)

def setPCA9685Freq(freq):
    freq = 0.9*freq # Arduinoのライブラリより
    prescaleval = 25000000.0    # 25MHz
    prescaleval /= 4096.0       # 12-bit
    prescaleval /= float(freq)
    prescaleval -= 1.0
    prescale = int(math.floor(prescaleval + 0.5))
    oldmode = bus.read_byte_data(address_pca9685, 0x00)
    newmode = (oldmode & 0x7F) | 0x10             # スリープモード
    bus.write_byte_data(address_pca9685, 0x00, newmode) # スリープモードへ
    bus.write_byte_data(address_pca9685, 0xFE, prescale) # プリスケーラーをセット
    bus.write_byte_data(address_pca9685, 0x00, oldmode)
    time.sleep(0.005)
    bus.write_byte_data(address_pca9685, 0x00, oldmode | 0xa1)

def setPCA9685Duty(channel, on, off):
    channelpos = 0x6 + 4*channel
    try:
        bus.write_i2c_block_data(address_pca9685, channelpos, [on&0xFF, on>>8, off&0xFF, off>>8] )
    except IOError:
       pass
def shoulder(angle): # 35 degree ~  35 degree
    duty=int((angle+35)*305/70)+150
    setPCA9685Duty(0, 0, duty)
    
def arm(angle): # -35 degree ~ 35 degree
    duty=int((angle+35)*290/70)+120
    setPCA9685Duty(1, 0, duty)

def finger(angle): # 0 degree ~ 35 degree
    duty=int(angle*200/35)+250
    setPCA9685Duty(2, 0, duty)
       
def s_left(a1,a2):
    for i in range(a2-a1):
        shoulder(a1)
        a1+=1
        sleep(0.1)
    return a1
def s_right(a1,a2):
    for i in range(a1-a2):
        shoulder(a1)
        a1-=1
        sleep(0.1)
    return a1

def a_up(a1,a2):
    for i in range(a2-a1):
        arm(a1)
        a1+=1
        sleep(0.1)
    return a1

def a_down(a1,a2):
    for i in range(a1-a2):
        arm(a1)
        a1-=1
        sleep(0.1)
    return a1
    
def f_close(a1,a2):
    for i in range(a2-a1):
        finger(a1)
        a1+=1
        sleep(0.1)
    return a1

def f_open(a1,a2):
    for i in range(a1-a2):
        finger(a1)
        a1-=1
        sleep(0.1)
    return a1
        


# servo motorを用いるための設定
address_pca9685 = 0x40
resetPCA9685()
setPCA9685Freq(50)

finger(0)
sleep(2)
arm(0)
sleep(2)
shoulder(0)
sleep(2)

A1=0
A2=20
A1 = a_up(A1,A2)
S1=-35
S2=0
S1 = s_left(S1,S2)
A2= -20
A1 = a_down(A1,A2)
F1=0
F2=25
F1 = f_close(F1,F2)
A2=20
A1=a_up(A1,A2)
S2=-30                                  
S2=s_right(S1,S2)
A2=-10
A1=a_down(A1,A2)
F2=0
F1=f_open(F1,F2)






